package com.sun.jndi.toolkit.ctx;

import javax.naming.directory.SearchControls;
import javax.naming.directory.SearchResult;
import javax.naming.NamingEnumeration;
import javax.naming.directory.DirContext;
import javax.naming.directory.ModificationItem;
import javax.naming.NamingException;
import javax.naming.directory.Attributes;
import javax.naming.Name;

public abstract class ComponentDirContext extends PartialCompositeDirContext
{
    protected ComponentDirContext() {
        this._contextType = 2;
    }
    
    protected abstract Attributes c_getAttributes(Name p0, String[] p1, Continuation p2) throws NamingException;
    
    protected abstract void c_modifyAttributes(Name p0, int p1, Attributes p2, Continuation p3) throws NamingException;
    
    protected abstract void c_modifyAttributes(Name p0, ModificationItem[] p1, Continuation p2) throws NamingException;
    
    protected abstract void c_bind(Name p0, Object p1, Attributes p2, Continuation p3) throws NamingException;
    
    protected abstract void c_rebind(Name p0, Object p1, Attributes p2, Continuation p3) throws NamingException;
    
    protected abstract DirContext c_createSubcontext(Name p0, Attributes p1, Continuation p2) throws NamingException;
    
    protected abstract NamingEnumeration<SearchResult> c_search(Name p0, Attributes p1, String[] p2, Continuation p3) throws NamingException;
    
    protected abstract NamingEnumeration<SearchResult> c_search(Name p0, String p1, SearchControls p2, Continuation p3) throws NamingException;
    
    protected abstract NamingEnumeration<SearchResult> c_search(Name p0, String p1, Object[] p2, SearchControls p3, Continuation p4) throws NamingException;
    
    protected abstract DirContext c_getSchema(Name p0, Continuation p1) throws NamingException;
    
    protected abstract DirContext c_getSchemaClassDefinition(Name p0, Continuation p1) throws NamingException;
    
    protected Attributes c_getAttributes_nns(Name name, String[] array, Continuation continuation) throws NamingException {
        this.c_processJunction_nns(name, continuation);
        return null;
    }
    
    protected void c_modifyAttributes_nns(Name name, int n, Attributes attributes, Continuation continuation) throws NamingException {
        this.c_processJunction_nns(name, continuation);
    }
    
    protected void c_modifyAttributes_nns(Name name, ModificationItem[] array, Continuation continuation) throws NamingException {
        this.c_processJunction_nns(name, continuation);
    }
    
    protected void c_bind_nns(Name name, Object o, Attributes attributes, Continuation continuation) throws NamingException {
        this.c_processJunction_nns(name, continuation);
    }
    
    protected void c_rebind_nns(Name name, Object o, Attributes attributes, Continuation continuation) throws NamingException {
        this.c_processJunction_nns(name, continuation);
    }
    
    protected DirContext c_createSubcontext_nns(Name name, Attributes attributes, Continuation continuation) throws NamingException {
        this.c_processJunction_nns(name, continuation);
        return null;
    }
    
    protected NamingEnumeration<SearchResult> c_search_nns(Name name, Attributes attributes, String[] array, Continuation continuation) throws NamingException {
        this.c_processJunction_nns(name, continuation);
        return null;
    }
    
    protected NamingEnumeration<SearchResult> c_search_nns(Name name, String s, SearchControls searchControls, Continuation continuation) throws NamingException {
        this.c_processJunction_nns(name, continuation);
        return null;
    }
    
    protected NamingEnumeration<SearchResult> c_search_nns(Name name, String s, Object[] array, SearchControls searchControls, Continuation continuation) throws NamingException {
        this.c_processJunction_nns(name, continuation);
        return null;
    }
    
    protected DirContext c_getSchema_nns(Name name, Continuation continuation) throws NamingException {
        this.c_processJunction_nns(name, continuation);
        return null;
    }
    
    protected DirContext c_getSchemaClassDefinition_nns(Name name, Continuation continuation) throws NamingException {
        this.c_processJunction_nns(name, continuation);
        return null;
    }
    
    @Override
    protected Attributes p_getAttributes(Name name, String[] array, Continuation continuation) throws NamingException {
        HeadTail p_resolveIntermediate = this.p_resolveIntermediate(name, continuation);
        Attributes attributes = null;
        switch (p_resolveIntermediate.getStatus()) {
            case 3: {
                attributes = this.c_getAttributes_nns(p_resolveIntermediate.getHead(), array, continuation);
                break;
            }
            case 2: {
                attributes = this.c_getAttributes(p_resolveIntermediate.getHead(), array, continuation);
                break;
            }
        }
        return attributes;
    }
    
    @Override
    protected void p_modifyAttributes(Name name, int n, Attributes attributes, Continuation continuation) throws NamingException {
        HeadTail p_resolveIntermediate = this.p_resolveIntermediate(name, continuation);
        switch (p_resolveIntermediate.getStatus()) {
            case 3: {
                this.c_modifyAttributes_nns(p_resolveIntermediate.getHead(), n, attributes, continuation);
                break;
            }
            case 2: {
                this.c_modifyAttributes(p_resolveIntermediate.getHead(), n, attributes, continuation);
                break;
            }
        }
    }
    
    @Override
    protected void p_modifyAttributes(Name name, ModificationItem[] array, Continuation continuation) throws NamingException {
        HeadTail p_resolveIntermediate = this.p_resolveIntermediate(name, continuation);
        switch (p_resolveIntermediate.getStatus()) {
            case 3: {
                this.c_modifyAttributes_nns(p_resolveIntermediate.getHead(), array, continuation);
                break;
            }
            case 2: {
                this.c_modifyAttributes(p_resolveIntermediate.getHead(), array, continuation);
                break;
            }
        }
    }
    
    @Override
    protected void p_bind(Name name, Object o, Attributes attributes, Continuation continuation) throws NamingException {
        HeadTail p_resolveIntermediate = this.p_resolveIntermediate(name, continuation);
        switch (p_resolveIntermediate.getStatus()) {
            case 3: {
                this.c_bind_nns(p_resolveIntermediate.getHead(), o, attributes, continuation);
                break;
            }
            case 2: {
                this.c_bind(p_resolveIntermediate.getHead(), o, attributes, continuation);
                break;
            }
        }
    }
    
    @Override
    protected void p_rebind(Name name, Object o, Attributes attributes, Continuation continuation) throws NamingException {
        HeadTail p_resolveIntermediate = this.p_resolveIntermediate(name, continuation);
        switch (p_resolveIntermediate.getStatus()) {
            case 3: {
                this.c_rebind_nns(p_resolveIntermediate.getHead(), o, attributes, continuation);
                break;
            }
            case 2: {
                this.c_rebind(p_resolveIntermediate.getHead(), o, attributes, continuation);
                break;
            }
        }
    }
    
    @Override
    protected DirContext p_createSubcontext(Name name, Attributes attributes, Continuation continuation) throws NamingException {
        HeadTail p_resolveIntermediate = this.p_resolveIntermediate(name, continuation);
        DirContext dirContext = null;
        switch (p_resolveIntermediate.getStatus()) {
            case 3: {
                dirContext = this.c_createSubcontext_nns(p_resolveIntermediate.getHead(), attributes, continuation);
                break;
            }
            case 2: {
                dirContext = this.c_createSubcontext(p_resolveIntermediate.getHead(), attributes, continuation);
                break;
            }
        }
        return dirContext;
    }
    
    @Override
    protected NamingEnumeration<SearchResult> p_search(Name name, Attributes attributes, String[] array, Continuation continuation) throws NamingException {
        HeadTail p_resolveIntermediate = this.p_resolveIntermediate(name, continuation);
        NamingEnumeration<SearchResult> namingEnumeration = null;
        switch (p_resolveIntermediate.getStatus()) {
            case 3: {
                namingEnumeration = this.c_search_nns(p_resolveIntermediate.getHead(), attributes, array, continuation);
                break;
            }
            case 2: {
                namingEnumeration = this.c_search(p_resolveIntermediate.getHead(), attributes, array, continuation);
                break;
            }
        }
        return namingEnumeration;
    }
    
    @Override
    protected NamingEnumeration<SearchResult> p_search(Name name, String s, SearchControls searchControls, Continuation continuation) throws NamingException {
        HeadTail p_resolveIntermediate = this.p_resolveIntermediate(name, continuation);
        NamingEnumeration<SearchResult> namingEnumeration = null;
        switch (p_resolveIntermediate.getStatus()) {
            case 3: {
                namingEnumeration = this.c_search_nns(p_resolveIntermediate.getHead(), s, searchControls, continuation);
                break;
            }
            case 2: {
                namingEnumeration = this.c_search(p_resolveIntermediate.getHead(), s, searchControls, continuation);
                break;
            }
        }
        return namingEnumeration;
    }
    
    @Override
    protected NamingEnumeration<SearchResult> p_search(Name name, String s, Object[] array, SearchControls searchControls, Continuation continuation) throws NamingException {
        HeadTail p_resolveIntermediate = this.p_resolveIntermediate(name, continuation);
        NamingEnumeration<SearchResult> namingEnumeration = null;
        switch (p_resolveIntermediate.getStatus()) {
            case 3: {
                namingEnumeration = this.c_search_nns(p_resolveIntermediate.getHead(), s, array, searchControls, continuation);
                break;
            }
            case 2: {
                namingEnumeration = this.c_search(p_resolveIntermediate.getHead(), s, array, searchControls, continuation);
                break;
            }
        }
        return namingEnumeration;
    }
    
    @Override
    protected DirContext p_getSchema(Name name, Continuation continuation) throws NamingException {
        DirContext dirContext = null;
        HeadTail p_resolveIntermediate = this.p_resolveIntermediate(name, continuation);
        switch (p_resolveIntermediate.getStatus()) {
            case 3: {
                dirContext = this.c_getSchema_nns(p_resolveIntermediate.getHead(), continuation);
                break;
            }
            case 2: {
                dirContext = this.c_getSchema(p_resolveIntermediate.getHead(), continuation);
                break;
            }
        }
        return dirContext;
    }
    
    @Override
    protected DirContext p_getSchemaClassDefinition(Name name, Continuation continuation) throws NamingException {
        DirContext dirContext = null;
        HeadTail p_resolveIntermediate = this.p_resolveIntermediate(name, continuation);
        switch (p_resolveIntermediate.getStatus()) {
            case 3: {
                dirContext = this.c_getSchemaClassDefinition_nns(p_resolveIntermediate.getHead(), continuation);
                break;
            }
            case 2: {
                dirContext = this.c_getSchemaClassDefinition(p_resolveIntermediate.getHead(), continuation);
                break;
            }
        }
        return dirContext;
    }
}
